#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
} global;

struct Push
{
    float PR;
    float PG;
    float PB;
};

uniform Push params;

layout(binding = 2) uniform sampler2D OriginalHistory0;
layout(binding = 3) uniform sampler2D AfterglowPassFeedback;

layout(location = 0) in vec2 vTexCoord;
layout(location = 0) out vec4 FragColor;

void main()
{
    vec3 color = texture(OriginalHistory0, vTexCoord).xyz;
    vec3 accumulate = texture(AfterglowPassFeedback, vTexCoord).xyz;
    float w = 1.0;
    if (((color.x + color.y) + color.z) < 0.0058823530562222003936767578125)
    {
        w = 0.0;
    }
    vec3 result = mix(max(mix(color, accumulate, vec3(0.4900000095367431640625) + vec3(params.PR, params.PG, params.PB)) - vec3(0.007843137718737125396728515625), vec3(0.0)), color, vec3(w));
    FragColor = vec4(result, w);
}

