#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 OutputSize;
    uint FrameCount;
    float bloom;
    float halation;
    float scans;
    float gamma_c;
    float smart_ei;
    float ei_limit;
    float sth;
    float overscanX;
    float overscanY;
    float c_shape;
    float intres;
    float prescalex;
    float scan_falloff;
    float rolling_scan;
    float bloom_dist;
} global;

struct Push
{
    float TATE;
    float IOS;
    float OS;
    float BLOOM;
    float brightboost;
    float brightboost1;
    float gsl;
    float scanline1;
    float scanline2;
    float beam_min;
    float beam_max;
    float beam_size;
    float h_sharp;
    float s_sharp;
    float csize;
    float bsize1;
    float warpX;
    float warpY;
    float glow;
    float vertmask;
    float spike;
};

uniform Push params;

layout(location = 0) in vec4 Position;
layout(location = 0) out vec2 vTexCoord;
layout(location = 1) in vec2 TexCoord;

void main()
{
    gl_Position = global.MVP * Position;
    vTexCoord = TexCoord * 1.00010001659393310546875;
}

